import datetime
import time
import inspect
from .LogLevels import Level


class Log:
    def __init__(self, level: Level, text: str, *args, _object=None, _file=inspect.stack()[1].filename):
        """
            Create a log message.
        """
        self.level = level
        self.text = text
        self.args = args
        self.created_on = time.time()
        self.file = _file
        self._object = _object

    def format_time(self, fmt: str):
        return datetime.datetime.fromtimestamp(self.created_on).strftime(fmt)

    def class_str(self):
        if self._object:
            prefix = f'{type(self._object).__name__}'
            if hasattr(self._object, 'name'):
                prefix += ":"
                prefix += self._object.name
            return prefix
        else:
            return None

    def format_text(self):
        return f'{self.text.format(*self.args)}'

